/*
 * Copyright (C) 2019 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "linkerconfig/namespacebuilder.h"

using android::linkerconfig::modules::AsanPath;
using android::linkerconfig::modules::Namespace;

namespace android {
namespace linkerconfig {
namespace contents {
Namespace BuildRuntimeNamespace([[maybe_unused]] const Context& ctx) {
  Namespace ns("runtime", /*is_isolated=*/true,
               /*is_visible=*/!ctx.IsVendorSection());
  ns.AddSearchPath("/apex/com.android.art/${LIB}", AsanPath::SAME_PATH);
  ns.AddSearchPath("/apex/com.android.runtime/${LIB}", AsanPath::SAME_PATH);
  // TODO(b/119867084): Restrict to Bionic dlopen dependencies and PALette
  // library when it exists.
  ns.CreateLink(ctx.IsVendorSection() ? "system" : "default", true);

  return ns;
}
}  // namespace contents
}  // namespace linkerconfig
}  // namespace android
